package ru.dbotthepony.mc.otm.menu.widget;

import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.TranslatableComponent;
import net.minecraft.world.inventory.ContainerData;
import ru.dbotthepony.mc.otm.menu.FormattingHelper;
import ru.dbotthepony.mc.otm.menu.MatteryMenu;
import ru.dbotthepony.mc.otm.screen.MatteryScreen;

import java.util.List;
import java.util.function.Supplier;

public class ProgressGaugeWidget<T extends MatteryMenu> extends GaugeWidget<T> {
	protected final Supplier<Float> progress_supplier;

	protected final ContainerData progress_container = new ContainerData() {
		private int value;

		@Override
		public int get(int i) {
			return value;
		}

		@Override
		public void set(int i, int i1) {
			value = i1;
		}

		@Override
		public int getCount() {
			return 1;
		}
	};

	public ProgressGaugeWidget(T menu, int x, int y, Supplier<Float> progress) {
		super(menu, x, y);
		fill_order = GaugeDirection.LEFT_TO_RIGHT;
		addDataSlots(progress_container);
		progress_supplier = progress;
	}

	public ProgressGaugeWidget(T menu, int x, int y) {
		this(menu, x, y, null);
	}

	@Override
	public int getImageWidth() {
		return 22;
	}

	@Override
	public int getImageHeight() {
		return 16;
	}

	@Override
	public int getImageX() {
		return 0;
	}

	@Override
	public int getImageY() {
		return 132;
	}

	@Override
	public void updateServer() {
		if (progress_supplier != null)
			progress_container.set(0, (int) (progress_supplier.get() * 10000f));
	}

	@Override
	public boolean renderTooltip(MatteryScreen<T> screen, PoseStack pose, int local_x, int local_y, int mouse_x, int mouse_y) {
		if (is_hovered) {
			List<Component> text = List.of(
				new TranslatableComponent("otm.gui.progress_widget", String.format("%.2f", progress_container.get(0) / 100f))
			);

			screen.renderComponentTooltip(pose, text, mouse_x, mouse_y);

			return true;
		}

		return false;
	}

	@Override
	public float getLevel() {
		return progress_container.get(0) / 10000f;
	}
}
